# Learning Predictive Models from Observation and Interaction

This code is heavily based on the code from Stochastic Adversarial Video Prediction, from [here](https://github.com/alexlee-gk/video_prediction).

Our primary model is located in the file `video_prediction/models/savp_model.py`.


# Usage

## Getting Started ###
### Prerequisites
- Linux or macOS
- Python 3
- CPU or NVIDIA GPU + CUDA CuDNN

### Installation
- Clone this repo:
```bash
git clone -b master --single-branch https://github.com/alexlee-gk/video_prediction.git
cd video_prediction
```
- Install TensorFlow >= 1.5 and dependencies from http://tensorflow.org/
- Install ffmpeg (optional, used to generate GIFs for visualization, e.g. in TensorBoard)
- Install other dependencies
```bash
pip install -r requirements.txt
```
Note: in macOS, make sure that bash >= 4.0 is used (needed for associative arrays in `download_model.sh` script).



## Training

Run `python3 train.py --train_batch_sizes '9' '3' --train_input_dirs /PATH/TO/ROBOT/DATA /PATH/TO/HUMAN/DATA/ --train_datasets sawyer  human --train_dataset_hparams_files hparams/ssar/dataset_hparams_no_state.json hparams/ssar/dataset_hparams_no_action.json --train_dataset_hparams 'image_view=[0]' 'image_view=[0]' --val_input_dirs /PATH/TO/VAL/DATA/ROBOT/ /PATH/TO/VAL/DATA/HUMAN --val_datasets sawyer human --val_dataset_hparams_files hparams/ssar/dataset_hparams_no_state.json hparams/ssar/dataset_hparams_no_action.json --val_dataset_hparams 'image_view=[0]' 'image_view=[0]' --model savp --output_dir /PATH/TO/OUTPUT/DIR --model_hparams_dict hparams/ssar/final_hparams.json`

## Testing

Run `python generate.py --input_dir=/PATH/TO/TEST/DATASET --checkpoint=/PATH/TO/TRAINED/MODEL/FOLDER --mode=test --dataset sawyer --model savp --num_stochastic_samples=1 --dataset_hparams_file=hparams/ssar/dataset_hparams_no_state_no_zip.json`


